package sun.dc.pr;

import java.security.AccessController;
import java.security.PrivilegedAction;
import sun.dc.path.FastPathProducer;
import sun.dc.path.PathException;
import sun.dc.path.PathError;
import sun.dc.path.PathConsumer;

public class PathFiller implements PathConsumer
{
    public static final int EOFILL = 1;
    public static final int NZFILL = 2;
    public static final int MAX_PATH = 1000000;
    public static final int TILE_IS_ALL_0 = 0;
    public static final int TILE_IS_ALL_1 = 1;
    public static final int TILE_IS_GENERAL = 2;
    static int tileSizeL2S;
    private static int tileSize;
    private static float tileSizeF;
    public static final float maxPathF = 1000000.0f;
    private long cData;
    
    public static final boolean validLoCoord(float n) {
        return n >= -1000000.0f;
    }
    
    public static final boolean validHiCoord(float n) {
        return n <= 1000000.0f;
    }
    
    public PathFiller() {
        this.cInitialize();
        this.reset();
    }
    
    public native void dispose();
    
    protected static void classFinalize() throws Throwable {
        cClassFinalize();
    }
    
    public PathConsumer getConsumer() {
        return null;
    }
    
    public native void setFillMode(int p0) throws PRError;
    
    public native void beginPath() throws PathError;
    
    public native void beginSubpath(float p0, float p1) throws PathError;
    
    public native void appendLine(float p0, float p1) throws PathError;
    
    public native void appendQuadratic(float p0, float p1, float p2, float p3) throws PathError;
    
    public native void appendCubic(float p0, float p1, float p2, float p3, float p4, float p5) throws PathError;
    
    public native void closedSubpath() throws PathError;
    
    public native void endPath() throws PathError, PathException;
    
    public void useProxy(FastPathProducer fastPathProducer) throws PathError, PathException {
        fastPathProducer.sendTo(this);
    }
    
    public native long getCPathConsumer();
    
    public native void getAlphaBox(int[] p0) throws PRError;
    
    public native void setOutputArea(float p0, float p1, int p2, int p3) throws PRError, PRException;
    
    public native int getTileState() throws PRError;
    
    public void writeAlpha(byte[] array, int n, int n2, int n3) throws PRError, PRException, InterruptedException {
        this.writeAlpha8(array, n, n2, n3);
    }
    
    public void writeAlpha(char[] array, int n, int n2, int n3) throws PRError, PRException, InterruptedException {
        this.writeAlpha16(array, n, n2, n3);
    }
    
    private native void writeAlpha8(byte[] p0, int p1, int p2, int p3) throws PRError, PRException;
    
    private native void writeAlpha16(char[] p0, int p1, int p2, int p3) throws PRError, PRException;
    
    public native void nextTile() throws PRError;
    
    public native void reset();
    
    private static native void cClassInitialize();
    
    private static native void cClassFinalize();
    
    private native void cInitialize();
    
    static {
        AccessController.doPrivileged(new PrivilegedAction<Void>() {
            @Override
            public Void run() {
                System.loadLibrary("dcpr");
                return null;
            }
        });
        cClassInitialize();
    }
}
